require '_h2ph_pre.ph';

require 'linux/list.ph';
require 'linux/sched.ph';
require 'linux/netdevice.ph';
require 'linux/pagemap.ph';
unless(defined(&LIST_HEAD_INIT)) {
    sub LIST_HEAD_INIT {
	local($name) = @_;
	eval q({ ($name), ($name) });
    }
}
unless(defined(&DECLARE_WAITQUEUE)) {
    sub DECLARE_WAITQUEUE {
	local($wait, $current) = @_;
	eval q('struct wait_queue' $wait = { $current,  &NULL });
    }
}
unless(defined(&DECLARE_WAIT_QUEUE_HEAD)) {
    sub DECLARE_WAIT_QUEUE_HEAD {
	local($wait) = @_;
	eval q( &wait_queue_head_t $wait);
    }
}
unless(defined(&init_waitqueue_head)) {
    sub init_waitqueue_head {
	local($x) = @_;
	eval q(*$x= &NULL);
    }
}
unless(defined(&init_MUTEX)) {
    sub init_MUTEX {
	local($x) = @_;
	eval q(*($x)= &MUTEX);
    }
}
unless(defined(&init_MUTEX_LOCKED)) {
    sub init_MUTEX_LOCKED {
	local($x) = @_;
	eval q(*($x)= &MUTEX_LOCKED);
    }
}
unless(defined(&DECLARE_MUTEX)) {
    sub DECLARE_MUTEX {
	local($name) = @_;
	eval q('struct semaphore' $name= &MUTEX);
    }
}
unless(defined(&DECLARE_MUTEX_LOCKED)) {
    sub DECLARE_MUTEX_LOCKED {
	local($name) = @_;
	eval q('struct semaphore' $name= &MUTEX_LOCKED);
    }
}
unless(defined(&__set_current_state)) {
    sub __set_current_state {
	local($state_value) = @_;
	eval q( &do {  ($current->{state}) = $state_value; }  &while (0));
    }
}
if(defined(&__SMP__)) {
    eval 'sub set_current_state {
        local($state_value) = @_;
	    eval q( &do {  &mb();  &__set_current_state($state_value); }  &while (0));
    }' unless defined(&set_current_state);
} else {
    eval 'sub set_current_state {
        local($state_value) = @_;
	    eval q( &__set_current_state($state_value));
    }' unless defined(&set_current_state);
}
unless(defined(&__exit)) {
    sub __exit () {	1;}
}
if(defined(&__alpha)) {
    undef(&CONFIG_APM) if defined(&CONFIG_APM);
}
unless(defined(&proc_mkdir)) {
    sub proc_mkdir {
	local($buf, $usbdir) = @_;
	eval q( &create_proc_entry($buf,  &S_IFDIR, $usbdir));
    }
}
unless(defined(&pci_enable_device)) {
    sub pci_enable_device {
	local($x) = @_;
	eval q(0);
    }
}
unless(defined(&VID_HARDWARE_CPIA)) {
    sub VID_HARDWARE_CPIA () {	24;}
}
unless(defined(&VID_HARDWARE_OV511)) {
    sub VID_HARDWARE_OV511 () {	27;}
}
unless(defined(&page_address)) {
    sub page_address {
	local($x) = @_;
	eval q(($x |  &PAGE_OFFSET));
    }
}
if(defined(&MODULE)) {
    eval 'sub module_init {
        local($x) = @_;
	    eval q(\'int\'  &init_module( &void) {  &return $x(); });
    }' unless defined(&module_init);
    eval 'sub module_exit {
        local($x) = @_;
	    eval q( &void  &cleanup_module( &void) { $x(); });
    }' unless defined(&module_exit);
    eval 'sub THIS_MODULE () {(& &__this_module);}' unless defined(&THIS_MODULE);
} else {
    eval 'sub module_init {
        local($x) = @_;
	    eval q(\'int\' $x &_module( &void) {  &return $x(); });
    }' unless defined(&module_init);
    eval 'sub module_exit {
        local($x) = @_;
	    eval q( &void $x &_module( &void) { $x(); });
    }' unless defined(&module_exit);
    eval 'sub THIS_MODULE () { &NULL;}' unless defined(&THIS_MODULE);
}
unless(defined(&TTY_DRIVER_NO_DEVFS)) {
    sub TTY_DRIVER_NO_DEVFS () {	0;}
}
unless(defined(&__initcall)) {
    sub __initcall {
	local($x) = @_;
	eval q();
    }
}
unless(defined(&net_device)) {
    sub net_device () {	 &device;}
}
unless(defined(&dev_kfree_skb_irq)) {
    sub dev_kfree_skb_irq {
	local($a) = @_;
	eval q( &dev_kfree_skb($a));
    }
}
unless(defined(&netif_wake_queue)) {
    sub netif_wake_queue {
	local($dev) = @_;
	eval q( &clear_bit(0,  ($dev->{tbusy})));
    }
}
unless(defined(&netif_stop_queue)) {
    sub netif_stop_queue {
	local($dev) = @_;
	eval q( &set_bit(0,  ($dev->{tbusy})));
    }
}
unless(defined(&netif_start_queue)) {
    sub netif_start_queue {
	local($dev) = @_;
	eval q( &do {  ($dev->{tbusy}) = 0;  ($dev->{interrupt}) = 0;  ($dev->{start}) = 1; }  &while (0));
    }
}
unless(defined(&netif_queue_stopped)) {
    sub netif_queue_stopped {
	local($dev) = @_;
	eval q( ($dev->{tbusy}));
    }
}
unless(defined(&netif_running)) {
    sub netif_running {
	local($dev) = @_;
	eval q( ($dev->{start}));
    }
}
unless(defined(&NET_XMIT_SUCCESS)) {
    sub NET_XMIT_SUCCESS () {	0;}
}
unless(defined(&NET_XMIT_DROP)) {
    sub NET_XMIT_DROP () {	1;}
}
unless(defined(&NET_XMIT_CN)) {
    sub NET_XMIT_CN () {	2;}
}
unless(defined(&tty_register_devfs)) {
    sub tty_register_devfs {
	local($driver,$flags,$minor) = @_;
	eval q();
    }
}
unless(defined(&tty_unregister_devfs)) {
    sub tty_unregister_devfs {
	local($driver,$minor) = @_;
	eval q();
    }
}
unless(defined(&DECLARE_FSTYPE)) {
    sub DECLARE_FSTYPE {
	local($var,$type,$read,$flags) = @_;
	eval q('struct file_system_type' $var = {  &name: $type,  &read_super: $read,  &fs_flags: $flags, });
    }
}
1;
